import { of } from 'rxjs';
export class ResponseHandler {
    constructor(error) {
        this.error = error;
        this.errorHandler = x => {
            return of(this.error(new Error(this.parseError(x.error))));
        };
    }
    parseError(e) {
        let msg = '';
        if (e) {
            if (typeof e === 'string')
                msg = e;
            else if (e instanceof Array) {
                e.map(x => x).forEach(x => (msg += `${x.path}: ${x.errors[0]}`));
            }
            else
                msg = e.toString();
        }
        return msg === '' ? null : msg;
    }
}
//# sourceMappingURL=response.js.map