import { EntityState as State } from '@ngrx/entity';
import { Entity } from '../model/entity';
import { Id } from '../model/key/id';
export interface EntityState<T extends Entity, Key extends Id> extends State<T> {
    isLoading: boolean;
    isLoaded: boolean;
    isAdding: boolean;
    isAdded: boolean;
    isUpdating: boolean;
    isUpdated: boolean;
    isDeleting: boolean;
    isDeleted: boolean;
    selectedId: any;
    selected: T;
    error: any;
    totalRecords: number;
    currentPage: number;
}
export declare const defaultState: {
    isLoading: boolean;
    isLoaded: boolean;
    isAdding: boolean;
    isAdded: boolean;
    isUpdating: boolean;
    isUpdated: boolean;
    isDeleting: boolean;
    isDeleted: boolean;
    selected: any;
    selectedId: any;
    error: any;
    totalRecords: number;
    currentPage: number;
};
