import { Injectable } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { Platform } from '@ionic/angular';
import { Network } from '@ionic-native/network/ngx';
import * as i0 from "@angular/core";
import * as i1 from "@ionic/angular";
import * as i2 from "@ionic-native/network/ngx";
export class NetworkService {
    constructor(platform, device) {
        this.platform = platform;
        this.device = device;
        this.isOfflineMode = false;
        this.isOfflineMode$ = new BehaviorSubject(false);
        this.isNative = this.platform.is('cordova');
        this.isOfflineMode$.subscribe(x => (this.isOfflineMode = x));
    }
    isOnline() {
        if (this.isNative && this.device.type) {
            return this.device.type !== 'none';
        }
        else
            return navigator.onLine;
    }
    isOffline() {
        if (this.isNative && this.device.type) {
            return this.device.type === 'none';
        }
        else
            return !navigator.onLine;
    }
    /**
     * opt-in/out to offline mode
     */
    setOffline(isOffline) {
        this.isOfflineMode$.next(isOffline);
    }
}
NetworkService.ɵfac = function NetworkService_Factory(t) { return new (t || NetworkService)(i0.ɵɵinject(i1.Platform), i0.ɵɵinject(i2.Network)); };
NetworkService.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: NetworkService, factory: NetworkService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(NetworkService, [{
        type: Injectable,
        args: [{ providedIn: 'root' }]
    }], function () { return [{ type: i1.Platform }, { type: i2.Network }]; }, null); })();
//# sourceMappingURL=network.js.map