export class QueryString {
    constructor() {
        this.eq = '=';
        this.sep = '&';
    }
    build(q) {
        if (!q)
            return '';
        return Object.keys(q)
            .map(k => {
            const ks = this.encode(k) + this.eq;
            return Array.isArray(q[k])
                ? q[k].map(v => ks + this.encode(v)).join(this.sep)
                : ks + this.encode(q[k]);
        })
            .join(this.sep);
    }
    encode(v) {
        return encodeURIComponent(this.stringify(v));
    }
    stringify(v) {
        switch (typeof v) {
            case 'string':
                return v;
            case 'boolean':
                return v ? 'true' : 'false';
            case 'number':
                return isFinite(v) ? v.toString() : '';
            default:
                return '';
        }
    }
}
//# sourceMappingURL=query-string.js.map