import { BehaviorSubject } from 'rxjs';
export class StatusService {
    constructor() {
        this.loading$ = new BehaviorSubject(false);
    }
    setLoading(loading) {
        this.loading$.next(loading);
    }
    /**
     * emit loaded status based on whether or not batch of
     * observables have completed
     */
    setLoaded(loading) {
        loading.subscribe(bools => {
            const loaded = bools.every(x => !x);
            this.setLoading(!loaded);
        });
    }
}
//# sourceMappingURL=status.js.map