import { Store } from '@ngrx/store';
import { Session } from '../model/session';
import { User } from '../model/user';
import * as i0 from "@angular/core";
export interface Payload {
    type: string;
    payload: any;
}
declare type ActionType = 'ADDED' | 'ADDED_MANY' | 'UPDATED' | 'UPDATED_MANY' | 'DELETED' | 'DELETED_MANY';
export declare abstract class Websocket {
    protected store: Store<any>;
    private environment;
    private ws;
    private retryMax;
    private retryCount;
    private retryInterval;
    abstract load<U extends User>(user: U): void;
    abstract getAction(response: Payload): any;
    constructor(store: Store<any>, environment: {
        wss: string;
    });
    connect(session: Session): void;
    disconnect(): void;
    private isConnected;
    private connectToSocket;
    private createSocket;
    private subscribeToSocket;
    private retry;
    private ping;
    private actionRegex;
    protected getActionType(_type: string): ActionType;
    static ɵfac: i0.ɵɵFactoryDeclaration<Websocket, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Websocket>;
}
export {};
